// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.




#ifndef ELEMENTUPDATE_2D_H
#define ELEMENTUPDATE_2D_H

#include "FixVec.h"
#include "ElementUpdate.h"
#include "VelocityExt.h"

using namespace AMDiS;

class ElementUpdate_2d : public ElementUpdate
{
public:
  ElementUpdate_2d(VelocityExt *velExt_ = NULL)
    : ElementUpdate(velExt_)
  {}

  /** \brief
   * Realization of ElementUpdate::calcElementUpdate. Calculates the Bornemann 
   * update for an element.
   */
  double calcElementUpdate(const FixVec<WorldVector<double> *, VERTEX> &vert,
			   FixVec<double, VERTEX> &uhVal);

private:
  WorldVector<double> xhminusYh, zhminusYh, xhminusZh;
};

#endif // ELEMENTUPDATE_2D_H

